---
layout: LayoutHome
description: 'Application performance monitor tool for distributed systems, especially designed for microservices, cloud native and container-based (Docker, K8s, Mesos) architectures.'
start: Quick Start
what:
  title: What is SkyWalking
  content:
    - SkyWalking is an Observability Analysis Platform and Application Performance Management system.
    - Provide distributed tracing, service mesh telemetry analysis, metric aggregation and visualization all-in-one solution.
    - Java, .Net Core, PHP, NodeJS, Golang, LUA agents supported
    - Istio + Envoy Service Mesh supported

feature:
  title: Feature List
  content:
    - Consistent in multiple scenarios. supported telemetry sources from language agents and service mesh.
    - Multiple language agents, including Java, .Net Core, PHP, NodeJS, Golang, LUA agents.
    - Light. No big data platform required, even observing the high payload cluster.
    - Modulization. Have multiple options for UI, storage, cluster managements.
    - Alarm supported.
    - Cool visualization solution.

user:
  title: Who is using SkyWalking
  content: Various companies and organizations use SkyWalking for research, production and commercial products.

news:
  title: Events & News
  content:
  - header: SkyWalking Chart 3.1.0 is released
    content: Support deploy SkyWalking 8.1.0.
    time: Aug. 13th, 2020
  - header: Welcome Wei Hua as new committer
    content: Based on his continuous contributions, Wei Hua (a.k.a [alonelaval](https://github.com/alonelaval)) has been voted as a new committer.
    time: Aug. 1st, 2020
  - header: SkyWalking 8.1.0 is released
    content: Support Kafka as an optional trace, JVM metrics, profiling snapshots and meter system data transport layer. Support Meter system, including the native metrics APIs and the Spring Sleuth adoption.
    time: Aug. 3rd, 2020
  - header: SkyWalking Python 0.2.0 is released
    content: Add multiple plugins and config to ignore endpoints with specific suffix.
    time: July. 28th, 2020
